/*
 * @(#)List.java
 * 
 * Christopher Deckers (chrriis@brainlex.com)
 * http://chrriis.brainlex.com
 * 
 * See the file "LICENSE.txt" for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package chrriis.uihierarchy.compatibility;

/**
 * The interface of the list types of collections.
 * @version 1.0 2004.01.11
 * @author Christopher Deckers (chrriis@brainlex.com)
 */
public interface List extends Collection {

  /**
   * Returns the element at the specified position in this list.
   * @param index The index.
   * @return The element.
   */
  public Object get(int index);

  /**
   * Inserts the specified element at the specified position in this list (optional operation).
   * @param index The index.
   * @param element The element.
   */
  public void add(int index, Object element);

  /**
   * Removes the element at the specified position in this list (optional operation).
   * @param index The index of the element to remove.
   * @return The element that was removed.
   */
  public Object remove(int index);

  /**
   * Replaces the element at the specified position in this list with the specified element (optional operation).
   * @param index The index at which to set the element.
   * @param element The element to set.
   * @return The element previously located at the specified position.
   */
  public Object set(int index, Object element);

  /**
   * Returns the index in this list of the first occurrence of the specified element, or -1 if this list does not contain this element.
   * @param o The element to look for.
   * @return The index.
   */
  public int indexOf(Object o);

}
