/*
 * @(#)LayoutHConstraints.java
 * 
 * Christopher Deckers (chrriis@brainlex.com)
 * http://chrriis.brainlex.com
 * 
 * See the file "LICENSE.txt" for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */
package chrriis.uihierarchy.constraints;

import java.awt.Container;

import chrriis.uihierarchy.SingleLevelAccessor;

/**
 * The interface that every layout constraints must extend.
 * @version 1.1 2003.11.03
 * @author Christopher Deckers (chrriis@brainlex.com)
 */
public interface LayoutHConstraints {

  /**
   * Create the constraints of a component. This method will return some
   * constraints, or null if none should be used, but can also set the
   * component's direct layout constraints.
   * @param accessor The accessor of the level for which to create the
   * constraints.
   * @param parentContainer The parent container.
   * @param constraints The constraints of the component.
   * @return The constraints to apply when the component will be added.
   */
  public Object createConstraints(SingleLevelAccessor accessor, Container parentContainer, Object constraints);

}
